<?php
/*** Cron Job ***/
add_filter( 'cron_schedules', 'hr_office_vacancy_license_check_cron_add_intervals' );
function hr_office_vacancy_license_check_cron_add_intervals( $schedules ) {   
    $schedules['every_day_hr_office_vacancy_license_check'] = array(
            'interval'  => 86400,
            'display'   => 'Every Day HROffice license check'
    );
    return $schedules;
}

/*** Schedule an action if it's not already scheduled ***/
if ( ! wp_next_scheduled( 'hr_office_vacancy_license_check_cron' ) ) {   
    wp_schedule_event( time(), 'every_day_hr_office_vacancy_license_check', 'hr_office_vacancy_license_check_cron' );
}

/*** Hook into that action that'll fire every day ***/
add_action( 'hr_office_vacancy_license_check_cron', 'hr_office_vacancy_license_check_func' );
function hr_office_vacancy_license_check_func() { 
    
	  $license = get_option( 'hr_office_vacancy_plugin_license_key' );
    $domain_name = $_SERVER['SERVER_NAME'];   

    $url  = 'https://license.nowonline.nl/api/validate-license-key';
    $body = array('domain' => $domain_name, 'license_key' => $license);

    $args = array(
        'method'      => 'POST',
        'timeout'     => 120,
        'sslverify'   => false,
        'headers'     => array(),
        'body'        => $body,
        'blocking'    => true,
        'httpversion' => '1.1',
        'cookies'     => array(),
    );

    $request = wp_remote_post( $url, $args );
    $license_response = json_decode( wp_remote_retrieve_body( $request ) ); 

    $license_data = $license_response->data->license_status;
   

    switch( $license_data ) {

      case 'expired' :        
        $license_status = 'invalid';
        break;

      case 'valid' :        
        $license_status = 'valid'; // will be either "valid" or "invalid"
        break;  

      case 'not_valid' :        
        $license_status = 'invalid';
        break;      

      default :        
        $license_status = 'invalid';
        break;
    }

    $referral_status = $license_response->data->referral_status;

    update_option( 'hr_office_vacancy_plugin_license_status', $license_status );
    update_option( 'hr_office_vacancy_referral_license_status', $referral_status );

}