<?php
//Form File Uploading
add_action('wp_ajax_hr_office_generic_form_upload_files', 'hr_office_generic_form_upload_files');
add_action('wp_ajax_nopriv_hr_office_generic_form_upload_files', 'hr_office_generic_form_upload_files'); 

function hr_office_generic_form_upload_files(){
    if( ! wp_verify_nonce( $_POST["file_upload_nonce"], 'file_upload_nonce' ) ){
        echo "This is due to unauthorized access. Try to refresh page!: #ref: fleksdgfupld213kjsdvgcsdh098";
        wp_die();
    }
    $shortcode_id = $_REQUEST['shortcode_id'];
    $max_upload = get_post_meta( $shortcode_id, '_job_apply_max_upload', true );
    $max_upload_kb = $max_upload * 1024; 
    $not_valid_formate_msg = get_post_meta( $shortcode_id, '_job_apply_not_valid_formate_msg', true );
    $too_large_msg = get_post_meta( $shortcode_id, '_job_apply_too_large_msg', true );

    if($_REQUEST['filenamedata'] == 'Picture'){
        $valid_formats = array("jpeg", "png", "jpg");  
    }else{
        $valid_formats = array("doc", "docx", "pdf", "jpeg", "png", "gif", "jpg");
    }

    $max_file_size = 1024 * $max_upload_kb;    
    if( $_SERVER['REQUEST_METHOD'] == "POST" ){ 
        $extension = pathinfo( $_FILES['files']['name'][0], PATHINFO_EXTENSION );
        if ( $_FILES['files']['error'][0] == 4 ) {
            
        }     
        if ( $_FILES['files']['error'][0] == 1 ){
            $upload_message[] = $too_large_msg;
        }          
        if ( $_FILES['files']['error'][0] == 0 ) {                   
            if ( $_FILES['files']['size'][0] > $max_file_size ) {
                $upload_message[] = $too_large_msg;
                  
            } elseif( ! in_array( strtolower( $extension ), $valid_formats ) ){
                $upload_message[] = $not_valid_formate_msg;
                                   
            } else{                       
                
            }
        }
    }

    if ( isset( $upload_message ) ) {
        foreach ( $upload_message as $msg ){       
            printf( __('%s', 'hr_office_vacancy_domain'), $msg );
        }
    }else{
        echo '';    
    }    
      
    exit();
}

//Form File Uploading
add_action('wp_ajax_action_apply_form_data_send', 'action_apply_form_data_send_fun');
add_action('wp_ajax_nopriv_action_apply_form_data_send', 'action_apply_form_data_send_fun'); 
function action_apply_form_data_send_fun(){ 
    if( ! wp_verify_nonce( $_POST["apply_form_data_nonce"], 'apply_form_data_nonce' ) ){
        echo "This is due to unauthorized access, try to refresh the page!: #ref: formupld_avgfska:::1)!21";
        wp_die();
    }
    $shortcode_id_post = $_REQUEST['shortcode_id'];
    $vacancy_id = $_REQUEST['vacancy_id'];
    $portal_id = get_post_meta( $shortcode_id_post, '_api_portal_id', true );
    $developer_key = get_post_meta( $shortcode_id_post, '_api_developer_key', true );
    $language_id = get_post_meta( $shortcode_id_post, '_api_language_id', true );
    $appdata = [
      'portalId' => $portal_id,
      'developerKey' => $developer_key,
      'vacancyId' => $vacancy_id,
      'keywords' => '',
      'location' => '',
      'categoryId' => '',
      'educationLevelId' => '',
      'languageId' => $language_id,
    ];
    $client = new SoapClient("https://api.hroffice.nl/HROfficeCoreService.asmx?wsdl");
    $respform = $client->GetApplicationByIdAndLanguage($appdata);
    $respformdata = $respform->GetApplicationByIdAndLanguageResult; 


    $xmldatastring = '<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">
    <soap:Body>
        <SetApplicationByIdV3 xmlns="http://api.hroffice.nl/">
        <portalId>'.$portal_id.'</portalId>
        <developerKey>'.$developer_key.'</developerKey>
        <vacancyId>'.$vacancy_id.'</vacancyId>
        <result>';    

            if($_FILES['CVFile']['name'] != ''){
                $namecv = $_FILES['CVFile']['name'];
                $datacv = file_get_contents($_FILES['CVFile']['tmp_name']);
                $base64cv = base64_encode($datacv);

                $xmldatastring .= '<CvFileName>'.$namecv.'</CvFileName>';
                $xmldatastring .= '<Cv>'.$base64cv.'</Cv>';
            }
            if($_FILES['FileNameExtra']['name'] != ''){
                $namecv2 = $_FILES['FileNameExtra']['name'];
                $datacv2 = file_get_contents($_FILES['FileNameExtra']['tmp_name']);
                $base64cv2 = base64_encode($datacv2);

                $xmldatastring .= '<SecondCvFileName>'.$namecv2.'</SecondCvFileName>';
                $xmldatastring .= '<SecondCv>'.$base64cv2.'</SecondCv>';
            }
            if($_FILES['Picture']['name'] != ''){
                $namepic = $_FILES['Picture']['name'];
                $datapic = file_get_contents($_FILES['Picture']['tmp_name']);
                $base64pic = base64_encode($datapic);

                $xmldatastring .= '<PictureFileName>'.$namepic.'</PictureFileName>';
                $xmldatastring .= '<Picture>'.$base64pic.'</Picture>';
            }
            if($_FILES['Attachment3']['name'] != ''){
                $nameatt3 = $_FILES['Attachment3']['name'];
                $dataatt3 = file_get_contents($_FILES['Attachment3']['tmp_name']);
                $base64att3 = base64_encode($dataatt3);

                $xmldatastring .= '<Attachment3FileName>'.$nameatt3.'</Attachment3FileName>';
                $xmldatastring .= '<Attachment3>'.$base64att3.'</Attachment3>';
            }
            if($_FILES['Attachment4']['name'] != ''){
                $nameatt4 = $_FILES['Attachment4']['name'];
                $dataatt4 = file_get_contents($_FILES['Attachment4']['tmp_name']);
                $base64att4 = base64_encode($dataatt4);

                $xmldatastring .= '<Attachment4FileName>'.$nameatt4.'</Attachment4FileName>';
                $xmldatastring .= '<Attachment4>'.$base64att4.'</Attachment4>';
            }
            if($_FILES['Attachment5']['name'] != ''){
                $nameatt5 = $_FILES['Attachment5']['name'];
                $dataatt5 = file_get_contents($_FILES['Attachment5']['tmp_name']);
                $base64att5 = base64_encode($dataatt5);

                $xmldatastring .= '<Attachment5FileName>'.$nameatt5.'</Attachment5FileName>';
                $xmldatastring .= '<Attachment5>'.$base64att5.'</Attachment5>';
            }
            if($_FILES['Attachment6']['name'] != ''){
                $nameatt6 = $_FILES['Attachment6']['name'];
                $dataatt6 = file_get_contents($_FILES['Attachment6']['tmp_name']);
                $base64att6 = base64_encode($dataatt6);

                $xmldatastring .= '<Attachment6FileName>'.$nameatt6.'</Attachment6FileName>';
                $xmldatastring .= '<Attachment6>'.$base64att6.'</Attachment6>';
            }

            $xmldatastring .= '<QuestionsAnswersTextList>';        
                foreach ($respformdata->QuestionsList->AvQuestionList as $fqkey => $fqval){
                    
                    if(is_array($respformdata->QuestionsList->AvQuestionList) == 1){
                        $questionid = $fqval->QuestionId;          
                        $question_value = $_REQUEST['question_'.$fqval->QuestionId.''];
                        $onlyOneResult = 'no';
                    }else{
                        $questionid = $respformdata->QuestionsList->AvQuestionList->QuestionId;          
                        $question_value = $_REQUEST['question_'.$respformdata->QuestionsList->AvQuestionList->QuestionId.''];
                        $onlyOneResult = 'yes';
                    }               

                    $xmldatastring .= '<QuestionAnswerText>
                        <QuestionId>'.$questionid.'</QuestionId>
                        <AnswerText>'.$question_value.'</AnswerText>
                    </QuestionAnswerText>';

                    if($onlyOneResult == 'yes'){
                        break;
                    }  
                }
            $xmldatastring .= '</QuestionsAnswersTextList>';
            
            $xmldatastring .=  '<ReactionsFieldsResults>';
            foreach ($respformdata->ReactionFields->AvReactionFields as $fkey => $fval){
            $fieldname = $fval->FieldName;
            $fieldtype = $fval->FieldType;
            $fieldvalue = $_REQUEST[$fval->FieldName];

            $xmldatastring .= '<AvReactionFieldsResult>
                    <FieldName>'.$fieldname.'</FieldName>
                    <FieldText>'.$fieldvalue.'</FieldText>
                    <FieldType>'.$fieldtype.'</FieldType>
                </AvReactionFieldsResult>';
            }
            $xmldatastring .= '</ReactionsFieldsResults>';

            $xmldatastring .= '<MailingLanguageId>'.$language_id.'</MailingLanguageId>
        </result>
        </SetApplicationByIdV3>
    </soap:Body>
    </soap:Envelope>';

    $url = "https://api.hroffice.nl/HROfficeCoreService.asmx";
    $curl = curl_init($url);
    curl_setopt($curl, CURLOPT_URL, $url);
    curl_setopt($curl, CURLOPT_POST, true);
    curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
    $headers = array(
        "Content-Type: text/xml; charset=utf-8",
    );
    curl_setopt($curl, CURLOPT_HTTPHEADER, $headers);

    curl_setopt($curl, CURLOPT_POSTFIELDS, $xmldatastring);
    curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
    curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);

    $resp = curl_exec($curl);
    curl_close($curl);

    $resp_xml_string     = simplexml_load_string($resp);
    $v3Response = $resp_xml_string->children('http://schemas.xmlsoap.org/soap/envelope/')->Body->children()->SetApplicationByIdV3Response;
    $v3Result = $v3Response->SetApplicationByIdV3Result;    
    $CandidateSid = (string) $v3Result->CandidateSid;
    $AvErrorCode = (string) $v3Result->Errors->AvError->Code;
    $AvErrorMessage = (string) $v3Result->Errors->AvError->Message;

    $ajaxResultArr = array('Code'=>$AvErrorCode, 'Message'=>$AvErrorMessage);

    //Referral Tool send data
    $referral_license_status = get_option( 'hr_office_vacancy_referral_license_status' );  
    $referral_tool_status = get_post_meta( $shortcode_id_post, '_job_apply_referral_tool_status', true );
    if(isset($_REQUEST['referral_code']) && $referral_tool_status == 'enabled' && $CandidateSid != '' && $referral_license_status == 'included'){
        $referral_code = $_REQUEST['referral_code'];
        $referral_api_url = get_post_meta( $shortcode_id_post, '_job_apply_referral_api_url', true );
        $referral_api_key = get_post_meta( $shortcode_id_post, '_job_apply_referral_api_key', true );

        $curl2 = curl_init();
        curl_setopt_array($curl2, array(
          CURLOPT_URL => $referral_api_url,
          CURLOPT_RETURNTRANSFER => true,
          CURLOPT_ENCODING => '',
          CURLOPT_MAXREDIRS => 10,
          CURLOPT_TIMEOUT => 0,
          CURLOPT_FOLLOWLOCATION => true,
          CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
          CURLOPT_CUSTOMREQUEST => 'POST',
          CURLOPT_SSL_VERIFYHOST => false,
          CURLOPT_SSL_VERIFYPEER => false,
          CURLOPT_POSTFIELDS =>'{
          "candidateId": "'.$CandidateSid.'",
          "code": "'.$referral_code.'",
          "vacancyId": "'.$vacancy_id.'"
        }',
          CURLOPT_HTTPHEADER => array(
            'Content-Type: application/json',
            'Accept: text/plain',
            'X-Api-Key: '.$referral_api_key.'',
          ),
        ));

        $response = curl_exec($curl2);

        curl_close($curl2);
    }

    //Return the api response
    echo json_encode($ajaxResultArr);    

    exit;
}

