<?php
function hr_office_shortcode_job_alert_form_func( $atts ) {
    $shortcode_id = $atts['id'];
    $portal_id = get_post_meta( $shortcode_id, '_api_portal_id', true );
    $developer_key = get_post_meta( $shortcode_id, '_api_developer_key', true );
    $language_id = get_post_meta( $shortcode_id, '_api_language_id', true );    

    $appdata = [
      'portalId' => $portal_id,
      'developerKey' => $developer_key,
      'keywords' => '',
      'location' => '',
      'categoryId' => '',
      'educationLevelId' => '',
      'languageId' => $language_id,
    ];
    $client = new SoapClient("https://api.hroffice.nl/HROfficeCoreService.asmx?wsdl");
    $res_filter = $client->GetJobAlert($appdata);    
    $resp_filter_data = $res_filter->GetJobAlertResult->Result->AvJobAlertFields;
    //print_r($resp_filter_data);
    $resp_filter_data_customfunction_key = '';
    $resp_filter_data_keywords_key = '';
    foreach ($resp_filter_data as $keyj => $valj) {
        if($valj->FieldName == 'CustomFunctions'){            
            $resp_filter_data_customfunction_key = $keyj;
        }
        if($valj->FieldName == 'Keywords'){            
            $resp_filter_data_keywords_key = $keyj;
        }
    }      
        
    $jobalert_fname = get_post_meta( $shortcode_id, '_jobalert_form_fname_label', true );
    $jobalert_lname = get_post_meta( $shortcode_id, '_jobalert_form_lname_label', true );
    $jobalert_email = get_post_meta( $shortcode_id, '_jobalert_form_email_label', true );
    $jobalert_discipline = get_post_meta( $shortcode_id, '_jobalert_form_discipline_label', true );
    $jobalert_submit = get_post_meta( $shortcode_id, '_jobalert_form_submit_label', true );
    $jobalert_abovecontent = get_post_meta( $shortcode_id, '_jobalert_form_above_content', true );

    $list_job_title_color = get_post_meta( $shortcode_id, '_list_job_title_color', true );
    $list_job_button_txt_color = get_post_meta( $shortcode_id, '_list_job_button_txt_color', true );
    $list_job_button_bg_color = get_post_meta( $shortcode_id, '_list_job_button_bg_color', true );
    $list_job_button_hover_color = get_post_meta( $shortcode_id, '_list_job_button_hover_color', true ); 

    $plugin_license_status  = get_option( 'hr_office_vacancy_plugin_license_status' );

    ob_start();

    if($plugin_license_status == 'valid')
    {
    ?>
    
    <style type="text/css">
        .hroffice-listlayout-form .text-container .form-group .left label{color: <?php echo $list_job_title_color; ?>;}
        .hroffice-listlayout-form .text-container h2{color: <?php echo $list_job_title_color; ?>;}
        .hroffice-listlayout-form .text-container button.btn-apply{background: <?php echo $list_job_button_bg_color; ?>; border-color: <?php echo $list_job_button_bg_color; ?>; color: <?php echo $list_job_button_txt_color; ?>;}
        .hroffice-listlayout-form .text-container .form-group .right .privacy-label, .hroffice-listlayout-form .text-container .form-group .right .privacy-label a{color: <?php echo $list_job_title_color; ?>;}
        .hroffice-listlayout-form .text-container .btn-apply:hover{color: <?php echo $list_job_button_bg_color; ?>;background-color: <?php echo $list_job_button_hover_color; ?>;}
    </style>    
    <div class="hroffice-listlayout-form vacancy-applyform-page jobalert-form-page">
        
        <div class="hr-office-form">
            <div class="container">
                <div class="jobalert-form-description-area">
                    <?php echo $jobalert_abovecontent; ?>
                </div>
                <div class="text-container">                    
                    
                    <form id="hroffice-job-alert-form" method="post">                        
                        <input type="hidden" name="shortcode_id" value="<?php echo $shortcode_id; ?>">                        
                        <?php 
                        $required_fields_kobalert = [];
                        ?>
                        <div class="form-group-divided">
                            <div class="form-group ">
                                <div class="left">
                                    <label for="">                                    
                                        <?php echo $jobalert_fname; ?><span class="field_required"> *</span>
                                    </label>
                                </div>                            
                                <div class="right">
                                    <input type="text" class="form-control" id="jobalert-fname" name="jobalert-fname" value=""> 
                                    <?php array_push($required_fields_kobalert, 'jobalert-fname'); ?>
                                </div>                            
                            </div>
                            <div class="form-group ">
                                <div class="left">
                                    <label for="">                                    
                                        <?php echo $jobalert_lname; ?><span class="field_required"> *</span>
                                    </label>
                                </div>                            
                                <div class="right">
                                    <input type="text" class="form-control" id="jobalert-lname" name="jobalert-lname" value=""> 
                                    <?php array_push($required_fields_kobalert, 'jobalert-lname'); ?>
                                </div>                            
                            </div>
                        </div>
                        <div class="form-group ">
                            <div class="left">
                                <label for="">                                    
                                    <?php echo $jobalert_email; ?><span class="field_required"> *</span>
                                </label>
                            </div>                            
                            <div class="right">
                                <input type="text" class="form-control" id="jobalert-email" name="jobalert-email" value=""> 
                                <?php array_push($required_fields_kobalert, 'jobalert-email'); ?>
                            </div>                            
                        </div>

                        <?php if($resp_filter_data_customfunction_key): ?>
                        <div class="form-group">
                            <div class="left">
                                <label class="jobalert-checkbox-label" for="">                                    
                                    <?php echo $jobalert_discipline; ?><span class="field_required"> *</span>
                                </label>
                            </div>                            
                            <div class="right jobalert-checkbox-area">
                                <?php
                                $resp_filter_data_customfunction_data = $resp_filter_data[$resp_filter_data_customfunction_key]->FieldValues->FieldValue;
                                //print_r($resp_filter_data_customfunction_data);
                                foreach($resp_filter_data_customfunction_data as $valc){
                                    $ValueText = $valc->ValueText;
                                    $ValueId = $valc->ValueId;                                
                                ?>
                                <div>
                                    <label>
                                        <input type="checkbox" class="" id="jobalert-discipline" name="jobalert-discipline" value="<?php echo $ValueId; ?>"> 
                                        <?php echo $ValueText; ?>
                                    </label>
                                </div>
                                <?php
                                } ?>                                                                
                            </div>                            
                        </div> 
                        <?php endif; ?> 
                         
                        <input type="hidden" name="jobalert-keywords" value="<?php echo $resp_filter_data_keywords_key; ?>">
                            
                        <div class="form-group">
                            <div class="actions">
                               <button class="btn btn-apply" id="btn-apply-jobalert"><?php echo $jobalert_submit; ?></button>
                               <input type="hidden" id="jobalert_form_data_nonce" name="jobalert_form_data_nonce" value="<?php echo wp_create_nonce('jobalert_form_data_nonce'); ?>">
                               <img class="apply-btn-loader" style="display: none;" src="<?php echo HR_OFFICE_VACANCY_PLUGIN_DIR_URL; ?>assets/img/loader-4.gif">
                               <img class="apply-btn-sucess" style="display: none;" src="<?php echo HR_OFFICE_VACANCY_PLUGIN_DIR_URL; ?>assets/img/sucess-icon.png">
                            </div>
                        </div>
                        
                    </form>
                </div>
            </div>
        </div>
        
    </div>
    
    <script>
        var required_fields_kobalert = <?php echo json_encode($required_fields_kobalert); ?>;
        
        jQuery('#hroffice-job-alert-form #btn-apply-jobalert').click(function(e){          
            e.preventDefault();
            jQuery('#hroffice-job-alert-form .apply-btn-sucess').hide();
            var err = '';            
            jQuery.each(required_fields_kobalert, function(key, value) {                
                if( !jQuery('#hroffice-job-alert-form #'+value+'').val()) {
                    jQuery('#hroffice-job-alert-form #'+value+'').addClass('warning');
                    err += 'yes';
                }else{
                    jQuery('#hroffice-job-alert-form #'+value+'').removeClass('warning');
                    err += 'no';
                }
            });

            var jobalert_discipline = jQuery("#hroffice-job-alert-form").find("input[name=jobalert-discipline]");            

            if(jobalert_discipline.length > 0){
                if(jQuery('input[name=jobalert-discipline]:checked').length == 0)
                {                
                    jQuery('.jobalert-checkbox-area').addClass('warning');
                    err += 'yes';
                }else{
                    jQuery('.jobalert-checkbox-area').removeClass('warning');
                    err += 'no';
                }                
            }

            
            
            //form submit
            if(err.indexOf("yes") == -1){ 
                jQuery('.apply-btn-loader').show();                               

                var ajaxurl = '<?php echo admin_url('admin-ajax.php'); ?>';
                var formData = new FormData(document.getElementById("hroffice-job-alert-form"));
                formData.append('action', 'action_job_alert_form_data_send');

                var selected_checkbox = "";
                
                jQuery.each(jobalert_discipline, function(key, val) {                    
                    if(jQuery(this).is(':checked')){
                        selected_checkbox += jQuery(val).attr('value')+',';
                    }
                });
                selected_checkbox = selected_checkbox.slice(0,-1);                
                formData.append('selected_checkbox', selected_checkbox);
                
                var thankyouurl = '/apply/thankyou/';
                jQuery.ajax({
                    url : ajaxurl,
                    type: 'POST',
                    data : formData,
                    processData: false,
                    contentType: false,                
                    success: function(response) {                        
                        jQuery('.apply-btn-loader').hide();
                        var returnedData = JSON.parse(response);
                        if(returnedData.Code == 3){ 
                            jQuery('#hroffice-job-alert-form .apply-btn-sucess').show();
                            jQuery('#hroffice-job-alert-form').trigger("reset");
                        }else{
                            alert(returnedData.Message);
                        }
                        
                    }
                });
            }

            

        });

        

    </script> 

<?php
    }else{
        echo '<h4 style="text-align: center;">'.__('Please activate the License first.','hr_office_vacancy_domain').'</h4>';
    }

    return ob_get_clean();
}
add_shortcode( 'hroffice-job-alert', 'hr_office_shortcode_job_alert_form_func' );