<?php
function hr_office_shortcode_display_func( $atts ) {
    $shortcode_id = $atts['id'];
    $portal_id = get_post_meta( $shortcode_id, '_api_portal_id', true );
    $developer_key = get_post_meta( $shortcode_id, '_api_developer_key', true );
    $language_id = get_post_meta( $shortcode_id, '_api_language_id', true );

    $appdata = [
      'portalId' => $portal_id,
      'developerKey' => $developer_key,
      'keywords' => '',
      'location' => '',
      'categoryId' => '',
      'educationLevelId' => '',
      'languageId' => $language_id,
    ];
    $client = new SoapClient("https://api.hroffice.nl/HROfficeCoreService.asmx?wsdl");
    $res_filter = $client->GetVacancyCustomFields($appdata);
    $resp_filter_data = $res_filter->GetVacancyCustomFieldsResult->CustomFields->AvVacancyCustomField;
        
    if(get_post_meta( $shortcode_id, '_api_selected_filters', true )){
        $api_selected_filters = get_post_meta( $shortcode_id, '_api_selected_filters', true );
    }else{
        $api_selected_filters = [];
    }    
    $job_listing_above_content = get_post_meta( $shortcode_id, '_job_listing_above_content', true );
    $filter_button_text = get_post_meta( $shortcode_id, '_list_filter_button_text', true );

    $list_job_title_size = get_post_meta( $shortcode_id, '_list_job_title_size', true );
    $list_job_other_data_size = get_post_meta( $shortcode_id, '_list_job_other_data_size', true );
    $list_job_title_color = get_post_meta( $shortcode_id, '_list_job_title_color', true );
    $list_job_button_txt_color = get_post_meta( $shortcode_id, '_list_job_button_txt_color', true );
    $list_job_button_bg_color = get_post_meta( $shortcode_id, '_list_job_button_bg_color', true );
    $list_job_data_hover_color = get_post_meta( $shortcode_id, '_list_job_data_hover_color', true );
    $list_job_button_hover_color = get_post_meta( $shortcode_id, '_list_job_button_hover_color', true );

    if(isset($_REQUEST['search'])){
       $searchval = $_REQUEST['search'];
    }else{
       $searchval = ''; 
    }

    $api_template_selected = get_post_meta( $shortcode_id, '_api_template_selected', true );

    $plugin_license_status  = get_option( 'hr_office_vacancy_plugin_license_status' );

    ob_start();

    if($plugin_license_status == 'valid')
    {
    ?>
    <style type="text/css">
        .hroff-vac-list-layout .listing-vacancy .inner-job-list{color: <?php echo $list_job_title_color; ?>;}
        .hroff-vac-list-layout .job-list .list-detail ul li:after{background-color: <?php echo $list_job_title_color; ?>;}
        .hroff-vac-list-layout .job-list .list-content h5{font-size: <?php echo $list_job_title_size; ?>px; color: <?php echo $list_job_title_color; ?>;}
        .hroff-vac-list-layout .job-list .list-detail ul li{font-size: <?php echo $list_job_other_data_size; ?>px;}
        .hroff-vac-list-layout .job-list .list-content .link{background-color: <?php echo $list_job_button_bg_color; ?>; color: <?php echo $list_job_button_txt_color; ?>; border-color: <?php echo $list_job_button_bg_color; ?>}
        .hroff-vac-list-layout .listing-vacancy .view-more-button button{background: <?php echo $list_job_button_bg_color; ?>; color: <?php echo $list_job_button_txt_color; ?>; border-color: <?php echo $list_job_button_bg_color; ?>}
        .hroff-vac-list-layout .vacancies-search-form .vacatureszoeken .form-group.button .find-vacancy-btn{background: <?php echo $list_job_button_bg_color; ?>; color: <?php echo $list_job_button_txt_color; ?>; border-color: <?php echo $list_job_button_bg_color; ?>}
        .hroff-vac-list-layout .listing-vacancy .view-more-button button:hover, .hroff-vac-list-layout .listing-vacancy .inner-job-list:hover .list-content .link, .hroff-vac-list-layout .vacancies-search-form .vacatureszoeken .form-group.button .find-vacancy-btn:hover{color: <?php echo $list_job_button_bg_color; ?>;background-color: <?php echo $list_job_button_hover_color; ?>;}
        .hroff-vac-list-layout .our-vacancy-header{color: <?php echo $list_job_title_color; ?>;}
        .hroff-vac-list-layout .listing-vacancy .inner-job-list:hover{background: <?php echo $list_job_data_hover_color; ?>;}
    </style>
    <section class="hroff-vac-list-layout">
        <div class="vacancies-search">
            <div class="vacancies-search-form">
                
                <div class="our-vacancy-header">
                    <?php echo $job_listing_above_content; ?>         
                </div>            
                <div class="">
                    <form id="filter-form" class="vacatureszoeken" action='' method="GET">
                        <div class="row">    
                            <input type="hidden" name="shortcode_id" value="<?php echo $atts['id']; ?>" />
                            <input type="hidden" name="current_page_id" value="<?php echo get_the_ID(); ?>" />
                            <div class="form-group">
                                <input type="text" name="search" value="<?php echo $searchval; ?>" placeholder="<?php echo __('Search','hr_office_vacancy_domain'); ?>" class="form-control form-control-sm" />
                                <template  id="filter_jobs_nonce" data-name="filter_jobs_nonce" data-value="<?php echo wp_create_nonce('filter_jobs_nonce'); ?>"></template>
                            </div>
                            <?php 
                            if($resp_filter_data){
                                foreach ($resp_filter_data as $ky_ftr => $value_fltr){
                                    if(in_array($value_fltr->Name, $api_selected_filters)):
                                        $api_filter_label = get_post_meta( $shortcode_id, '_api_filter_label_'.str_replace(' ', '_', $value_fltr->Name).'', true );
                                        
                                        if($api_filter_label){
                                            $api_filter_label_name = $api_filter_label;
                                        }else{
                                            $api_filter_label_name = $value_fltr->Name;
                                        }
                                    ?>
                                    <div class="form-group select">                    
                                        <select name="cats-<?php echo $value_fltr->Name; ?>" class="form-control form-control-sm">  
                                            <option value="" selected="true" disabled="disabled"><?php echo $api_filter_label_name; ?></option>
                                            <?php 
                                            if( isset( $value_fltr->ExtraData->SingleSelectDropDown->Options->AvVacancyCustomFiledOption ) ){
                                                $arr_fltr_options = $value_fltr->ExtraData->SingleSelectDropDown->Options->AvVacancyCustomFiledOption;
                                                if( is_array(  $arr_fltr_options ) ){
                                                    usort($arr_fltr_options, function($a, $b) {
                                                        return $a->Order > $b->Order;
                                                    });
                                                    foreach ($arr_fltr_options as $val_fltr_opt){ ?>
                                                        <option value="<?php echo $val_fltr_opt->Name; ?>" <?php if( isset($_REQUEST['cats-'.$value_fltr->Name.'']) && ($_REQUEST['cats-'.$value_fltr->Name.''] == $val_fltr_opt->Name) ){echo 'selected';} ?> ><?php echo $val_fltr_opt->Name; ?></option>
                                                    <?php } 
                                                }
                                            }?>                        
                                        </select>
                                    </div>
                                    <?php 
                                    endif;
                                }
                            } 
                            ?>                
                            
                            <div class="form-group button">
                                <input type="submit" value="<?php echo $filter_button_text; ?>" class="btn find-vacancy-btn"/>
                            </div>
                        </div>    
                    </form>
                    <input type="hidden" id="current-query" value="" />
                </div>
                
            </div>
        </div>

        <div class="vacancies-list">
            <div class="listing-vacancy">
                <div class="vacancies-layout-<?php echo $api_template_selected; ?>">
                    <img class="listdata-loader" style="display: none;" src="<?php echo HR_OFFICE_VACANCY_PLUGIN_DIR_URL; ?>assets/img/spinner-new.gif">                    	
                	<div id="all-products" class="row all-products"></div>
                </div>
            </div>
        </div>
    </section>

    <script>

        jQuery(document).ready(function($) {           

            var limit = <?php echo get_post_meta( $shortcode_id, '_api_loadmore_limit', true ); ?>;
            var offset = 0;
            var noMoreProducts = false;
            var loadingInProgress = false;
            var shortcode_id = <?php echo $atts['id']; ?>;
            var ajaxurl = '<?php echo admin_url('admin-ajax.php'); ?>';
            var current_page_id = <?php echo get_the_ID(); ?>;

            $(document).on('submit', '#filter-form', function(e){
                e.preventDefault();                
                let form = $(this);
                $('.listdata-loader').show(); 

                $.post(ajaxurl,                       
                       {
                           action: 'action_shortcode_listing_filters',
                           filter_jobs_nonce: $('#filter_jobs_nonce').data('value'),
                           formdata: $(form).serialize(),
                       }, function (data) {                    
                            $('#all-products').html(data);
                            $('.listdata-loader').hide();

                            let formQueries = {};
                            $.each($('#filter-form').serializeArray(), function(_, input) {
                              formQueries[input.name] = input.value;
                            });                                
                            $('#current-query').val(JSON.stringify(formQueries));                            
                            
                            offset = limit;
                            noMoreProducts = false;
                            
                            const url = new URL(window.location);
                            $.each(formQueries, function(key, value) {
                                if( key !== 'shortcode_id' && key !== 'current_page_id' ){
                                    url.searchParams.set(key, value);
                                }                              
                            });
                            window.history.pushState({}, '', url);

                        }
                )

            });

            function loadProducts( extraQueries = {}) {                
                if (noMoreProducts) return;                
                let queries = {
                    'offset' : offset,
                    'limit' : limit,
                    'loadmore' : 'loadmore',
                    'shortcode_id' : shortcode_id,
                    'current_page_id' : current_page_id,
                }; 

                if(location.search){
                    var urlvars = [], hash;
                    var hashes = window.location.href.slice(window.location.href.indexOf('?') + 1).split('&');
                    for(var i = 0; i < hashes.length; i++)
                    {
                        hash = hashes[i].split('=');
                        urlvars[hash[0]] = hash[1];
                    }
                    var urlvarsObject = Object.assign({}, urlvars);
                    if( ! jQuery.isEmptyObject(urlvarsObject) ) {
                        $.each(urlvarsObject, function(param, value){
                          queries[param] = value.replace(/\+/g, ' ');                      
                        });
                    }
                }
                               
                // Additional Queries
                if( ! jQuery.isEmptyObject(extraQueries) ) {
                    $.each(extraQueries, function(param, value){
                      queries[param] = value;
                    });
                }

                $('.listdata-loader').show();
                if (!loadingInProgress) {                    
                    loadingInProgress = true;
                    $.post(ajaxurl,                       
                           {
                               action: 'action_shortcode_listing_filters',
                               filter_jobs_nonce: $('#filter_jobs_nonce').data('value'),
                               formdata: queries,
                           }, function (data) {                    
                                if(!data) {
                                    noMoreProducts = true;
                                    $('.view-more-button').remove();
                                }
                                else {
                                    offset += limit;                                    
                                    $('.view-more-button').remove();                                    
                                    $('#all-products').append(data);
                                    $('.listdata-loader').hide();                                    
                                }                                
                                loadingInProgress = false;
                            }
                    )
                }                
            }
            
            $(document).on('click', '#load-more', function() {                
                let currentQuery = {};
                var loadmore_htmlval = $('#load-more').html();                
                $('#load-more').html(loadmore_htmlval+'...').prop('disabled', true);                
                if($('#current-query').val().length) {
                    currentQuery = JSON.parse($('#current-query').val());
                }
                loadProducts( currentQuery ); 
            });

            loadProducts();
        })
    </script>

<?php
    }else{
        echo '<h4 style="text-align: center;">'.__('Please activate the License first.','hr_office_vacancy_domain').'</h4>';
    }

    return ob_get_clean();
}
add_shortcode( 'hroffice-vacancy', 'hr_office_shortcode_display_func' );